<!-- $Id: mailbox.jsp,v 1.16 2006/01/20 15:06:27 pbradler Exp $ -->
<%@ page contentType="text/html; charset=utf-8" import="
  java.util.Date,
  java.util.List,
  java.text.SimpleDateFormat,
  javax.servlet.http.HttpServletRequest,
  SK.gnome.dwarf.utils.io.HTMLPrintWriter,
  SK.gnome.dwarf.mail.MailException,
  SK.gnome.dwarf.mail.mime.*,
  SK.gnome.dwarf.mail.store.*,
  SK.gnome.dwarf.mail.web.*"
%>
<jsp:useBean id="webmail" class="SK.gnome.dwarf.mail.web.Webmail" scope="session">
  <jsp:setProperty name="webmail" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<jsp:setProperty name="webmail" property="folderName" param="folder" />
<jsp:setProperty name="webmail" property="pageNumber" param="page" />
<jsp:useBean id="options" class="SK.gnome.dwarf.mail.web.Options" scope="session">
  <jsp:setProperty name="options" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<%!
  private static final int ALL = 1;
  private static final int NONE = 2;
  private static final int FLAG = 3;

  private int selectType;
  private MailFlag flag;
  private boolean set;

  private String getMessageCss(MailMessage msg) throws MailException
  { if (msg.isSet(MailFlag.DELETED))
      return "mbx_row_deleted";
    if (!msg.isSet(MailFlag.SEEN))
      return "mbx_row_unseen";
    return "mbx_row_seen";
  }

  private void setFlags(HttpServletRequest request, MailFolder folder, MailFlag flag, boolean set)
    throws MailException
  { String[] uids = request.getParameterValues("uid");
    if (uids != null)
      for (int i = 0; i < uids.length; i++)
      { long uid = Long.parseLong(uids[i]);
        MailMessage msg = folder.getMessage(uid);
        msg.setFlag(flag, set);
      }
  }

  private boolean select(MailMessage message) throws MailException
  { switch (selectType)
    { case ALL:
        return true;
      case NONE:
        return false;
      case FLAG:
        return message.isSet(flag) == set;
      default:
        return false;
    }
  }
%>
<%
  selectType = 0;  // no selected messages by default

  String format = getServletContext().getInitParameter("webmail.dateFormat");
  if (format == null)
    format = "MM/dd/yyyy HH:mm";
  SimpleDateFormat dateFormat = new SimpleDateFormat(format);

  MailFolder folder = webmail.getFolder();
  try
  { folder.open(MailFolder.READ_WRITE);
    folder.getNewMessages();

    if (request.getParameter("expunge") != null)
    { folder.expunge();
    }
    else if (request.getParameter("delete") != null)
    { long uid = Long.parseLong(request.getParameter("uid"));
      MailMessage msg = folder.getMessage(uid);
      msg.setFlag(MailFlag.DELETED, !msg.isSet(MailFlag.DELETED));
    }
    else if (request.getParameter("operation") != null)
    { String op = request.getParameter("operation");
      if (op.equals("select"))
      { String select = request.getParameter("selection");
        if (select.equals("none"))
          selectType = NONE;
        else if (select.equals("all"))
          selectType = ALL;
        else if (select.equals("deleted"))
        { selectType = FLAG;
          flag = MailFlag.DELETED;
          set = true;
        }
        else if (select.equals("undeleted"))
        { selectType = FLAG;
          flag = MailFlag.DELETED;
          set = false;
        }
        else if (select.equals("seen"))
        { selectType = FLAG;
          flag = MailFlag.SEEN;
          set = true;
        }
        else if (select.equals("unseen"))
        { selectType = FLAG;
          flag = MailFlag.SEEN;
          set = false;
        }
        else if (select.equals("answered"))
        { selectType = FLAG;
          flag = MailFlag.ANSWERED;
          set = true;
        }
        else if (select.equals("unanswered"))
        { selectType = FLAG;
          flag = MailFlag.ANSWERED;
          set = false;
        }
        else if (select.equals("flagged"))
        { selectType = FLAG;
          flag = MailFlag.FLAGGED;
          set = true;
        }
        else if (select.equals("unflagged"))
        { selectType = FLAG;
          flag = MailFlag.FLAGGED;
          set = false;
        }
      }
      else if (op.equals("mark"))
      { String action = request.getParameter("action");
        if (action.equals("deleted"))
          setFlags(request, folder, MailFlag.DELETED, true);
        else if (action.equals("undeleted"))
          setFlags(request, folder, MailFlag.DELETED, false);
        else if (action.equals("seen"))
         setFlags(request, folder, MailFlag.SEEN, true);
        else if (action.equals("unseen"))
          setFlags(request, folder, MailFlag.SEEN, false);
        else if (action.equals("answered"))
          setFlags(request, folder, MailFlag.ANSWERED, true);
        else if (action.equals("unanswered"))
          setFlags(request, folder, MailFlag.ANSWERED, false);
        else if (action.equals("flagged"))
          setFlags(request, folder, MailFlag.FLAGGED, true);
        else if (action.equals("unflagged"))
          setFlags(request, folder, MailFlag.FLAGGED, false);
      }
      else if (op.equals("move"))
      { String target = request.getParameter("target");
        MailFolder f = webmail.getDefaultFolder().getFolder(target);
        String[] uids = request.getParameterValues("uid");
        if (uids != null)
          for (int i = 0; i < uids.length; i++)
          { long uid = Long.parseLong(uids[i]);
            MailMessage msg = folder.getMessage(uid);
            f.copyMessage(msg);
            msg.setFlag(MailFlag.DELETED, true);
          }
      }
    }

    int pageSize = options.getPageSize();
    int count = folder.getMessageCount();
    int pageCnt = count / pageSize;
    if (count < pageSize)
      pageCnt = 1;
    else if (count % pageSize > 0)
      pageCnt++;

    int pageNum = webmail.getPageNumber();
    if (pageNum > pageCnt)
      pageNum = pageCnt;

    int interval = options.getRefreshingInterval();
%>
<html>
<head>
  <title>Dwarf Webmail</title>
  <link href="site.css" rel="stylesheet" type="text/css">
<%  if (interval > 0) { %>
  <meta http-equiv="refresh" content="<%= interval %>;url=mailbox.jsp">
<%  } %>
  <script language="JavaScript">
  <!--
    function message(uid)
    { window.open("message.jsp?uid=" + uid, "", "top=40,left=40,width=740,height=530,scrollbars=yes");
    }

    function f_delete()
    { document.mailbox.action.options.selectedIndex=1;
      f_submit("mark");
    }

    function f_undelete()
    { document.mailbox.action.options.selectedIndex=2;
      f_submit("mark");
    }

    function f_submit(op)
    { document.mailbox.operation.value = op;
      document.mailbox.submit();
    }
  //  --> 
  </script>
</head>
<body marginwidth="0" marginheight="0" leftmargin="6" topmargin="0">
<table border="0" cellpadding="4" cellspacing="4" width="90%">
<% if (request.getParameter("sent") != null) { %>
  <tr class="alert">
    <td colspan="2"><br>Message has been sent successfuly!</td>
  </tr>
<% } %>
  <tr>
    <td><br><span class="title"><%= folder.getFullName() %></span>
        <span class="subtitle"> - page <%= pageNum + "/" + pageCnt %></span>
    </td>
    <td class="info" align="right"><br>
      <b><%= folder.getMessageCount(MailFlag.SEEN, false) %> unseen </b>(<%= folder.getMessageCount() %> total)
    </td>
  </tr>
</table>
<table border="0" cellpadding="4" cellspacing="1" width="90%">
  <form name="mailbox" method="POST" action="mailbox.jsp">
  <input type="hidden" name="operation" value="none">
  <tr class="mbx_menu">
    <td colspan="8">
<%  if (pageNum > 1) { %><a href="mailbox.jsp?page=<%= pageNum-1 %>">&lt;&lt;</a> |<% } %>
      <a href="mailbox.jsp">Refresh</a> |
      <a href="javascript:f_delete();">Delete</a> |
      <a href="javascript:f_undelete();">Undelete</a> |
      <a href="mailbox.jsp?expunge=1">Expunge</a> |
      <a href="javascript:f_submit('select');">Select</a>
      <select name="selection" size="1" class="mbx_menu" onChange="document.mailbox.selection2.options.selectedIndex=this.selectedIndex; f_submit('select');">
        <option value="null">-------</option>
        <option value="none">none</option>
        <option value="all" >all</option>
        <option value="deleted">deleted</option>
        <option value="undeleted">undeleted</option>
        <option value="seen">seen</option>
        <option value="unseen">unseen</option>
        <option value="answered">answered</option>
        <option value="unanswered">unanswered</option>
        <option value="flagged">flagged</option>
        <option value="unflagged">unflagged</option>
      </select> |
      <a href="javascript:f_submit('mark');">Mark</a>
      <select name="action" size="1" class="mbx_menu" onChange="document.mailbox.action2.options.selectedIndex=this.selectedIndex; f_submit('mark');">
        <option value="none">-------</option>
        <option value="deleted">deleted</option>
        <option value="undeleted">undeleted</option>
        <option value="seen">seen</option>
        <option value="unseen">unseen</option>
        <option value="answered">answered</option>
        <option value="unanswered">unanswered</option>
        <option value="flagged">flagged</option>
        <option value="unflagged">unflagged</option>
      </select> |
      <a href="javascript:f_submit('move');">Move to</a>
      <select name="target" size="1" class="mbx_menu" onChange="document.mailbox.target2.options.selectedIndex=this.selectedIndex">
        <option value="none">-------</option>
<%
    MailFolder[] folders = webmail.getDefaultFolder().listFolders("*");
    java.util.Arrays.sort(folders);
    for (int i = 0; i < folders.length; i++)
    { String name = folders[i].getFullName();
      out.println("<option value=\""+ name + "\">" + name + "</option>");
    }
%>
      </select>
<%  if (pageNum < pageCnt) { %>| <a href="mailbox.jsp?page=<%= pageNum+1 %>">&gt;&gt;</a><% } %>
    </td>
  </tr>
  <tr class="mbx_header">
    <td>&nbsp;</td>
    <td><img src="images/flg.gif" alt="Flagged"></td>
    <td><img src="images/ans.gif" alt="Answered"></td>
    <td><img src="images/att.gif" alt="Multipart"></td>
    <td>From</td>
    <td>Subject</td>
    <td>Date</td>
    <td>Size</td>
  </tr>
<%
    MailMessage[] msgs = folder.getMessages();

    int start = msgs.length - (webmail.getPageNumber() - 1) * pageSize;
    int end = start - pageSize;
    if (end < 0)
      end = 0;

    for (int i = start; i > end; i--)
    { MailMessage msg = msgs[i-1];
      long uid = msg.getUID();
      String from = "( MIME PARSING ERROR )";
      String display = from;
      String subject = "( MIME PARSING ERROR )";
      String date = dateFormat.format(new Date(msg.getInternalDate()));
      boolean multipart = false;
      String css = getMessageCss(msg);
      String href = "javascript:message(" + uid + ");";
//      String href = "message.jsp?uid=" + uid + "\" target=\"_blank";
      try
      { MimePart part = msg.getMimePart();
        from = MimeUtility.decodeHeader(part.getHeader("From", null));
        Address[] addr = Address.parse(from);
        display = addr[0].getDisplayName();
        if (display == null)
          display = HTMLPrintWriter.encode(addr[0].getAddress());
        subject = part.getHeader("Subject", null);
        subject = (subject != null) ? MimeUtility.decodeHeader(subject) : "";
        multipart = part.isMimeType("multipart/*");
      }
      catch (AddressException ae)
      { application.log("Error while parsing message #" + msg.getUID(), ae);
        href = "servlet/part?uid=" + uid + "&source=1&error=1\" target=\"_blank";
        css = "mbx_row_error";
      }
      catch (MimeException me)
      { application.log("Error while parsing message #" + msg.getUID(), me);
        href = "servlet/part?uid=" + uid + "&source=1&error=1\" target=\"_blank";
        css = "mbx_row_error";
      }
      catch (Throwable th)
      { display=String.valueOf(msg.getUID());
        subject="Parsing ERROR!!!";
      }
      out.println("  <tr class=\"" + css + "\">");
      out.println("<td class=\"mbx_from\"><input class=\"" + css + "\" name=\"uid\" type=\"checkbox\" value=\""
                  + msg.getUID() + "\"" + (select(msg) ? " checked" : "") + "></td>");
      out.println("<td class=\"mbx_from\">" + (msg.isSet(MailFlag.FLAGGED) ? "<img src=\"images/flg.gif\">" : "") + "</td>");
      out.println("<td class=\"mbx_from\">" + (msg.isSet(MailFlag.ANSWERED) ? "<img src=\"images/ans.gif\">" : "") + "</td>");
      out.println("<td class=\"mbx_from\">" + (multipart ? "<img src=\"images/att.gif\">" : "") + "</td>");
      out.println("<td class=\"mbx_from\"><a href=\"" + href + "\">" + display + "</a></td>");
      out.println("<td class=\"mbx_subject\"><a href=\"" +  href + "\">" + subject + "</a></td>");
      out.println("<td class=\"mbx_date\">" + date + "</td>");
      long size = msg.getSize();
      if (size < 1024)
        size = 1024;
      out.println("<td class=\"mbx_size\" align=\"right\">" + (size/1024) + " kB</td>");
      out.println("  </tr>");      
    }
%>
  <tr class="mbx_menu">
    <td colspan="8">
<%  if (pageNum > 1) { %><a href="mailbox.jsp?page=<%= pageNum-1 %>">&lt;&lt;</a> |<% } %>
      <a href="mailbox.jsp">Refresh</a> |
      <a href="javascript:f_delete();">Delete</a> |
      <a href="javascript:f_undelete();">Undelete</a> |
      <a href="mailbox.jsp?expunge=1">Expunge</a> |
      <a href="javascript:f_submit('select');">Select</a>
      <select name="selection2" size="1" class="mbx_menu" onChange="document.mailbox.selection.options.selectedIndex=this.selectedIndex; f_submit('select');">
        <option value="null">-------</option>
        <option value="none">none</option>
        <option value="all" >all</option>
        <option value="deleted">deleted</option>
        <option value="undeleted">undeleted</option>
        <option value="seen">seen</option>
        <option value="unseen">unseen</option>
        <option value="answered">answered</option>
        <option value="unanswered">unanswered</option>
        <option value="flagged">flagged</option>
        <option value="unflagged">unflagged</option>
      </select> |
      <a href="javascript:f_submit('mark');">Mark</a>
      <select name="action2" size="1" class="mbx_menu" onChange="document.mailbox.action.options.selectedIndex=this.selectedIndex; f_submit('mark');">
        <option value="none">-------</option>
        <option value="deleted">deleted</option>
        <option value="undeleted">undeleted</option>
        <option value="seen">seen</option>
        <option value="unseen">unseen</option>
        <option value="answered">answered</option>
        <option value="unanswered">unanswered</option>
        <option value="flagged">flagged</option>
        <option value="unflagged">unflagged</option>
      </select> |
      <a href="javascript:f_submit('move');">Move to</a>
      <select name="target2" size="1" class="mbx_menu" onChange="document.mailbox.target.options.selectedIndex=this.selectedIndex">
        <option value="none">-------</option>
<%
    for (int i = 0; i < folders.length; i++)
    { String name = folders[i].getFullName();
      out.println("<option value=\""+ name + "\">" + name + "</option>");
    }
%>
      </select>
<%  if (pageNum < pageCnt) { %>| <a href="mailbox.jsp?page=<%= pageNum+1 %>">&gt;&gt;</a><% } %>
<%
  }
  finally
  { folder.close(true);
  }
%>
    </td>
  </tr>
  </form>
</table>
<p>&nbsp;</p>
</body>
</html>
