<!-- $Id: message.jsp,v 1.13 2005/06/08 14:49:35 suhrin Exp $ -->
<%@ page contentType="text/html; charset=utf-8" import="
  java.io.*,
  javax.servlet.jsp.JspWriter,
  javax.mail.internet.ContentType,
  javax.mail.internet.ParameterList,
  javax.mail.internet.ParseException,
  SK.gnome.dwarf.utils.io.HTMLPrintWriter,
  SK.gnome.dwarf.http.HTTPUtils,
  SK.gnome.dwarf.mail.MailException,
  SK.gnome.dwarf.mail.mime.*,
  SK.gnome.dwarf.mail.store.*,
  SK.gnome.dwarf.mail.web.*"
%>
<jsp:useBean id="webmail" class="SK.gnome.dwarf.mail.web.Webmail" scope="session">
  <jsp:setProperty name="webmail" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<jsp:useBean id="options" class="SK.gnome.dwarf.mail.web.Options" scope="session">
  <jsp:setProperty name="options" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<%!
  private long uid;      // this message's UID
  private boolean print; // whether to format output for printer

  private void printMessage(String num, MimePart part, JspWriter out) throws IOException, MailException
  { printHeaders(num, part, out);
    if (part.isMimeType("multipart/*"))
      printMultipart(num, part, out);
    else if (part.isMimeType("message/rfc822"))
      printMessage(num + "." + 1, part.getMimePart(0), out);
    else if (part.isMimeType("text/plain"))
      printTextPart(part, out);
    else if (!print)
      printPart(num, part, out);
  }

  private void printHeaders(String num, MimePart part, JspWriter out) throws IOException, MailException
  { if (num != null)
    { if (print)
        out.println("<tr class=\"msg_header\"><td colspan=\"2\"><hr noshade></td></tr>");
      int size = part.getRawSize();
      if (size < 1024)
        size = 1024;
      out.println("<tr class=\"msg_header_att\"><td colspan=\"2\"><b>" + num 
                  + " Attachment [message/rfc822, " + (size/1024) + " kB]</b></td></tr>");
    }
  
    String s = part.getHeader("Date", null);
    if (s != null)
      out.println("<tr class=\"msg_header\"><td><b>Date:</b></td><td>" + s + "</td></tr>");

    printAddress("From", part, out);
    printAddress("To", part, out);
    printAddress("Cc", part, out);

    s = part.getHeader("Subject", null);
    if (s != null)
      out.print("<tr class=\"msg_header\"><td><b>Subject:</b></td><td>"
                + HTMLPrintWriter.encode(MimeUtility.decodeHeader(s)) + "</td></tr>");
    if (print)
      out.println("<tr class=\"msg_header\"><td colspan=\"2\"><hr noshade></td></tr>");
  }

  private void printAddress(String header, MimePart part, JspWriter out) throws IOException, MailException
  { String css = "msg_header";
    String s = "( PARSE ERROR IN HEADER )";
    try
    { s = part.getHeader(header, null);
      if (s != null)
        s = Address.toString(s);
    }
    catch (AddressException ae)
    { if (!print)
        css = "msg_header_err";
    }
    catch (MimeException me)
    { if (!print)
        css = "msg_header_err";
    }
    if (s != null)
      out.println("<tr class=\"" + css + "\"><td><b>" + header + ":</b></td><td>" + HTMLPrintWriter.encode(s) + "</td></tr>");
  }

  private void printMultipart(String num, MimePart part, JspWriter out) throws IOException, MailException
  { for (int i = 0, n = part.getMimePartCount(); i < n; i++)
    { MimePart p = part.getMimePart(i);
      String s = (num != null) ? num + "." + (i+1) : Integer.toString(i+1);
      if (p.isMimeType("multipart/*"))
        printMultipart(s, p, out);
      else if (p.isMimeType("message/rfc822"))
        printMessage(s + "." + 1, p.getMimePart(0), out);
      else if (p.isMimeType("text/plain"))
        printTextPart(p, out);
      else if (!print)
        printPart(s, p, out);
    }
  }

  private void printPart(String num, MimePart part, JspWriter out) throws IOException, MailException
  { out.println("<tr class=\"msg_att\"><td colspan=\"2\">");
    String filename = null;
    String desc = null;
    try
    { String type = part.getHeader("Content-Type", null);
      if (type == null)
        type = "text/plain";
      else if (type.indexOf('/') == -1)  // should not happen!
      { int index = type.indexOf(';');
        if (index > 0)
          type = type.substring(0, index) + "/octet-stream" + type.substring(index); 
        else
          type += "/octet-stream";
      }
      ContentType ct = new ContentType(type);
      String p = ct.getParameter("name");
      if (p != null)
        filename = MimeUtility.decodeHeader(p);
      if (filename == null)
      { String s = part.getHeader("Content-Disposition", null);
        if (s != null)
        { int index = s.indexOf(';');
          if (index > 0)
          { ParameterList list = new ParameterList(s.substring(index));
            p = list.get("filename");
            if (p != null)
              filename = MimeUtility.decodeHeader(p);
          }
        }
      }
      if (filename == null)
        filename = "Attachment";
      desc = filename;
      String s = part.getHeader("Content-Description", null);
      if (s != null)
        desc += " (" + MimeUtility.decodeHeader(s) + ")";
      int size = part.getContentSize();
      if (size < 1024)
        size = 1024;
      desc = desc + " [" + ct.getBaseType() + ", " + (size/1024) + " kB]";
      if (num != null)
        desc = num + " " + desc;
    }
    catch (ParseException e)
    { throw new MailException("Error while parsing message", e);
    }
    filename = HTTPUtils.escapeURL(filename, "utf-8");
    out.println("<div><img src=\"images/att.gif\"> <a href=\"servlet/part/" + filename + "?uid="
                + uid + (num != null ? "&part=" + num : "") + "\" target=\"_blank\">" + desc + "</a></div>");
    out.println("</td></tr>");
  }

  private void printTextPart(MimePart part, JspWriter out) throws IOException, MailException
  { out.println("<tr class=\"msg\"><td colspan=\"2\"><pre>");
    try  
    { String s = part.getHeader("Content-Type", null);
      if (s == null)
        s = "text/plain";
      ContentType type = new ContentType(s);
      String cs = type.getParameter("charset");
      if (cs == null)
        cs = "us-ascii";
      cs = javax.mail.internet.MimeUtility.javaCharset(cs);
      InputStream in = null;
      try
      { in = part.getDecodedInputStream();
        BufferedReader reader = new BufferedReader(new InputStreamReader(in, cs));
        String line;
        while ((line = reader.readLine()) != null)
          printLine(HTMLPrintWriter.encode(line), out);
      }
      finally
      { try
        { in.close();
        }
        catch (Exception e)
        {
        }
      }
    }
    catch (ParseException e)
    { throw new MailException("Error while parsing message", e);
    }
    out.println("</pre></td></tr>");
  }

  private void printLine(String s, JspWriter out) throws IOException
  { if (s.length() <= 78)
      out.println(s);
    else
    { int index = s.lastIndexOf(' ', 78);
      if (index > 0)
      { out.println(s.substring(0, index));
        printLine(s.substring(index+1), out);
      }
      else
        out.println(s);
    }
  }
%>
<%
  print = request.getParameter("print") != null;
  boolean search = request.getParameter("search") != null;

  MailFolder folder = webmail.getFolder();
  try
  { folder.open(MailFolder.READ_WRITE);

    uid = Long.parseLong(request.getParameter("uid"));
    MailMessage msg = folder.getMessage(uid);
    MimePart part = msg.getMimePart();

    String from = MimeUtility.decodeAddressHeader(part.getHeader("From", null));
    Address addr = new Address(from);
    String display = addr.getDisplayName();
    if (display == null)
      display = HTMLPrintWriter.encode(addr.getAddress());
    String subject = part.getHeader("Subject", null);
    if (subject != null)
      subject = MimeUtility.decodeHeader(subject);
    else
      subject = "&nbsp;";

    boolean deleted = msg.isSet(MailFlag.DELETED);

    int num = msg.getNumber();
    long nextUID = 0;
    if (num < folder.getMessageCount())
      nextUID = folder.getMessage(num+1).getUID();
    long prevUID = 0;
    if (num > 1)
      prevUID = folder.getMessage(num-1).getUID();
%>
<html>
<head>
  <title>Dwarf Webmail</title>
  <link href="<%= print ? "print.css" : "site.css" %>" rel="stylesheet" type="text/css">
  <script language="JavaScript">
  <!--
    function m_del(uid)
    { window.opener.location = "mailbox.jsp?uid=" + uid + "&delete=1";
      window.close();
    }

    function m_close(refresh)
    { if (refresh)
        window.opener.location = "mailbox.jsp";
      window.close();
    }
  //  --> 
  </script>
</head>
<body marginwidth="0" marginheight="0" leftmargin="6" topmargin="0">
<% if (!print) { %>
<table border="0" cellpadding="4" cellspacing="4" width="710">
  <tr>
    <td>
      <br><span class="title"><%= folder.getFullName() %></span>
      <span class="subtitle"> - message <%= msg.getNumber() + "/" + folder.getMessageCount() %>
    </td>
    <td align="right">
      <br><span class="info">UID <%= uid %></span>
    </td>
  </tr>
</table>
<% } %>
<table border="0" cellpadding="4" cellspacing="1" width="710">
<%  if (!print) { %>
  <tr class="mbx_menu">
    <td colspan="2">
<%  if (prevUID > 0 && !search) { %><a href="message.jsp?uid=<%= prevUID %>">&lt;&lt;</a> |<% } %>
      <a href="compose.jsp?uid=<%= uid %>" target="_blank">Reply</a> |
      <a href="compose.jsp?uid=<%= uid %>&all=1" target="_blank">Reply to All</a> |
      <a href="compose.jsp?uid=<%= uid %>&forward=1" target="_blank">Forward</a> |
<%  if (!search) { %><a href="javascript:m_del(<%= uid %>);"><%= deleted ? "Undelete" : "Delete" %></a> |<% } %>
      <a href="message.jsp?uid=<%= uid %>&print=1" target="_blank">Print</a> |
      <a href="servlet/part?uid=<%= uid %>&source=1" target="_blank">Source</a>
<%  if (nextUID > 0 && !search) { %>| <a href="message.jsp?uid=<%= nextUID %>">&gt;&gt;</a><% } %>
    </td>
  </tr>
<% } %>
  <tr> 
    <td class="msg_title" colspan="2"> 
      <%= print ? "<hr noshade>" : "" %>
      <b><%= display %>:</b> <i><%= subject %></i>
      <%= print ? "<hr noshade>" : "" %>
    </td>
  </tr>
<%
    printMessage(null, part, out);
    if (!print)
    {
%>
  <tr class="mbx_menu">
    <td colspan="2">
<%  if (prevUID > 0 && !search) { %><a href="message.jsp?uid=<%= prevUID %>">&lt;&lt;</a> |<% } %>
      <a href="compose.jsp?uid=<%= uid %>" target="_blank">Reply</a> |
      <a href="compose.jsp?uid=<%= uid %>&all=1" target="_blank">Reply to All</a> |
      <a href="compose.jsp?uid=<%= uid %>&forward=1" target="_blank">Forward</a> |
<%  if (!search) { %><a href="javascript:m_del(<%= uid %>);"><%= deleted ? "Undelete" : "Delete" %></a> |<% } %>
      <a href="message.jsp?uid=<%= uid %>&print=1" target="_blank">Print</a> |
      <a href="servlet/part?uid=<%= uid %>&source=1" target="_blank">Source</a>
<%  if (nextUID > 0 && !search) { %>| <a href="message.jsp?uid=<%= nextUID %>">&gt;&gt;</a><% } %>
    </td>
  </tr>
  <tr> 
    <td colspan="2" align="center"> 
      <a href="javascript:m_close(<%= !search && options.getRefreshOnClose() %>);">
      <image src="images/close.gif" width="64" height="22" border="0"></a>
    </td>
  </tr>
<%
    }
    msg.setFlag(MailFlag.SEEN, true);
  }
  finally
  { folder.close(false);
  }
%>
</table>
<p>&nbsp;</p>
</body>
</html>
