<!-- $Id: results.jsp,v 1.8 2004/09/22 21:28:58 suhrin Exp $ -->
<%@ page contentType="text/html; charset=utf-8" import="
  java.util.Date,
  java.util.List,
  java.util.Iterator,
  java.text.SimpleDateFormat,
  java.util.StringTokenizer,
  SK.gnome.dwarf.utils.io.HTMLPrintWriter,
  SK.gnome.dwarf.mail.MailException,
  SK.gnome.dwarf.mail.mime.*,
  SK.gnome.dwarf.mail.store.*,
  SK.gnome.dwarf.mail.store.search.*"
%>
<jsp:useBean id="webmail" class="SK.gnome.dwarf.mail.web.Webmail" scope="session">
  <jsp:setProperty name="webmail" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<jsp:useBean id="options" class="SK.gnome.dwarf.mail.web.Options" scope="session">
  <jsp:setProperty name="options" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<%!
  private String getMessageCss(MailMessage msg) throws MailException
  { if (msg.isSet(MailFlag.DELETED))
      return "mbx_row_deleted";
    if (!msg.isSet(MailFlag.SEEN))
      return "mbx_row_unseen";
    return "mbx_row_seen";
  }
%>
<%
  String s = request.getParameter("folder");
  if (!s.equals(webmail.getFolderName()))
    webmail.setFolderName(s);

  SearchKeyList keys = new AndKey();
  String text = request.getParameter("text");
  String type = request.getParameter("for");
  String target = request.getParameter("in");
  String partial = request.getParameter("partial");

  if (target.equals("message"))
  { int keyType = (partial != null && partial.equals("true")) ? TextKey.PARTIAL : TextKey.WORD;
    if (type.equals("any"))
    { OrKey orKey = new OrKey();
      for (StringTokenizer st = new StringTokenizer(text); st.hasMoreTokens(); )
        orKey.addKey(new TextKey(keyType, st.nextToken(), "utf-8", true));
      keys.addKey(orKey);
    }
    else if (type.equals("all"))
    { for (StringTokenizer st = new StringTokenizer(text); st.hasMoreTokens(); )
        keys.addKey(new TextKey(keyType, st.nextToken(), "utf-8", true));
    }
    else
      keys.addKey(new TextKey(TextKey.WORD, text, "utf-8", true));
  }
  else
  { int keyType = (partial != null && partial.equals("true")) ? HeaderKey.PARTIAL : HeaderKey.WORD;
    if (type.equals("any"))
    { OrKey orKey = new OrKey();
      for (StringTokenizer st = new StringTokenizer(text); st.hasMoreTokens(); )
        orKey.addKey(new HeaderKey(keyType, "Subject", st.nextToken()));
      keys.addKey(orKey);
    }
    else if (type.equals("all"))
    { for (StringTokenizer st = new StringTokenizer(text); st.hasMoreTokens(); )
        keys.addKey(new HeaderKey(keyType, "Subject", st.nextToken()));
    }
    else
      keys.addKey(new HeaderKey(HeaderKey.WORD, "Subject", text));
  }

  String flagged = request.getParameter("flag_deleted");
  if (flagged != null)
    keys.addKey(new FlagKey(flagged.equals("1") ? FlagKey.SET : FlagKey.UNSET, MailFlag.DELETED));
  flagged = request.getParameter("flag_seen");
  if (flagged != null)
    keys.addKey(new FlagKey(flagged.equals("1") ? FlagKey.SET : FlagKey.UNSET, MailFlag.SEEN));
  flagged = request.getParameter("flag_answered");
  if (flagged != null)
    keys.addKey(new FlagKey(flagged.equals("1") ? FlagKey.SET : FlagKey.UNSET, MailFlag.ANSWERED));
  flagged = request.getParameter("flag_flagged");
  if (flagged != null)
    keys.addKey(new FlagKey(flagged.equals("1") ? FlagKey.SET : FlagKey.UNSET, MailFlag.FLAGGED));

  String days = request.getParameter("days");
  if (days.length() > 0)
  { long time = System.currentTimeMillis() - Integer.parseInt(days)*24*60*60*1000;
    keys.addKey(new InternalDateKey(DateKey.SINCE, time));
  }

  String format = getServletContext().getInitParameter("webmail.dateFormat");
  if (format == null)
    format = "MM/dd/yyyy HH:mm";
  SimpleDateFormat dateFormat = new SimpleDateFormat(format);

  MailFolder folder = webmail.getFolder();
  try
  { folder.open(MailFolder.READ_ONLY);

    MailMessage[] msgs = folder.search(keys);
    for (Iterator it = keys.getErrors(); it.hasNext(); )
      application.log("Searching error", (Exception)it.next());
%>
<html>
<head>
  <title>Dwarf Webmail</title>
  <link href="site.css" rel="stylesheet" type="text/css">
  <script language="JavaScript">
  <!--
    function message(uid)
    { window.open("message.jsp?uid=" + uid + "&search=1", "", "top=40,left=40,width=740,height=530,scrollbars=yes");
    }
  //  --> 
  </script>
</head>
<body marginwidth="0" marginheight="0" leftmargin="6" topmargin="0">
<table border="0" cellpadding="4" cellspacing="4" width="90%">
  <tr>
    <td colspan="2"><br>
      <span class="title"><b>"<%= text %>":</b></span>
      <span class="subtitle"><i><%= msgs.length %> matching messages found</i></span>
    </td>
  </tr>
</table>
<table border="0" cellpadding="4" cellspacing="1" width="90%">
  <tr class="mbx_header">
    <td><img src="images/flg.gif" alt="Flagged"></td>
    <td><img src="images/ans.gif" alt="Answered"></td>
    <td><img src="images/att.gif" alt="Multipart"></td>
    <td>From</td>
    <td>Subject</td>
    <td>Date</td>
    <td>Size</td>
  </tr>
<%
    for (int i = 0; i < msgs.length; i++)
    { MailMessage msg = msgs[i];
      long uid = msg.getUID();
      String from = "( MIME PARSING ERROR )";
      String display = from;
      String subject = "( MIME PARSING ERROR )";
      String date = dateFormat.format(new Date(msg.getInternalDate()));
      boolean multipart = false;
      String css = getMessageCss(msg);
      String href = "javascript:message(" + msg.getUID() + ");";
//      String href = "message.jsp?uid=" + msg.getUID() + "&search=1\" target=\"_blank";
      try
      { MimePart part = msg.getMimePart();
        from = MimeUtility.decodeHeader(part.getHeader("From", null));
        Address[] addr = Address.parse(from);
        display = addr[0].getDisplayName();
        if (display == null)
          display = HTMLPrintWriter.encode(addr[0].getAddress());
        subject = part.getHeader("Subject", null);
        subject = (subject != null) ? MimeUtility.decodeHeader(subject) : "";
        multipart = part.isMimeType("multipart/*");
      }
      catch (AddressException ae)
      { application.log("Error while parsing message #" + msg.getUID(), ae);
        href = "servlet/part?uid=" + uid + "&source=1&error=1\" target=\"_blank";
        css = "mbx_row_error";
      }
      catch (MimeException me)
      { application.log("Error while parsing message #" + msg.getUID(), me);
        href = "servlet/part?uid=" + uid + "&source=1&error=1\" target=\"_blank";
        css = "mbx_row_error";
      }
      out.println("  <tr class=\"" + css + "\">");
      out.println("<td class=\"mbx_from\">" + (msg.isSet(MailFlag.FLAGGED) ? "<img src=\"images/flg.gif\">" : "") + "</td>");
      out.println("<td class=\"mbx_from\">" + (msg.isSet(MailFlag.ANSWERED) ? "<img src=\"images/ans.gif\">" : "") + "</td>");
      out.println("<td class=\"mbx_from\">" + (multipart ? "<img src=\"images/att.gif\">" : "") + "</td>");
      out.println("<td class=\"mbx_from\"><a href=\"" + href + "\">" + display + "</a></td>");
      out.println("<td class=\"mbx_subject\"><a href=\"" +  href + "\">" + subject + "</a></td>");
      out.println("<td class=\"mbx_date\">" + date + "</td>");
      long size = msg.getSize();
      if (size < 1024)
        size = 1024;
      out.println("<td class=\"mbx_size\" align=\"right\">" + (size/1024) + " kB</td>");
      out.println("  </tr>");      
    }
  }
  finally
  { folder.close(false);
  }
%>
</table>
<p>&nbsp;</p>
</body>
</html>
