<!-- $Id: send.jsp,v 1.11 2004/09/22 21:28:58 suhrin Exp $ -->
<%@ page contentType="text/html; charset=utf-8" import="
  java.io.File,
  java.io.FileInputStream,
  java.util.List,
  SK.gnome.dwarf.main.*,
  SK.gnome.dwarf.utils.io.HTMLPrintWriter,
  SK.gnome.dwarf.mail.MailException,
  SK.gnome.dwarf.mail.mime.*,
  SK.gnome.dwarf.mail.store.*,
  SK.gnome.dwarf.mail.smtp.SMTPUtils,
  SK.gnome.dwarf.mail.smtp.SMTPServer,
  SK.gnome.dwarf.mail.web.*"
%>
<jsp:useBean id="webmail" class="SK.gnome.dwarf.mail.web.Webmail" scope="session">
  <jsp:setProperty name="webmail" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<jsp:useBean id="options" class="SK.gnome.dwarf.mail.web.Options" scope="session">
  <jsp:setProperty name="options" property="userName" value="<%= request.getRemoteUser() %>" />
</jsp:useBean>
<%
  MimeMessageBuilder message = new MimeMessageBuilder();
  String from = request.getParameter("from").trim();
  if (from.length() == 0)
    throw new MailException("No From address specified");
  from = HTMLPrintWriter.decode(from);
  String to = request.getParameter("to").trim();
  if (to.length() == 0)
    throw new MailException("No To address specified");
  to = HTMLPrintWriter.decode(to);
  String cc = request.getParameter("cc").trim();
  cc = HTMLPrintWriter.decode(cc);
  String subject = request.getParameter("subject");
  if (subject == null)
    throw new MailException("No subject specified");
  subject = HTMLPrintWriter.decode(subject);
  String text = SMTPUtils.wrapText(request.getParameter("text"));

  message.setFrom(from);
  message.setTo(to);
  if (cc.length() > 0)
    message.setCc(cc);
  message.setSubject(subject);
  String msgid = request.getParameter("msgid");
  if (msgid != null)
    message.setHeader("In-Reply-To", msgid);
  message.setHeader("X-Mailer", "Dwarf Mail Server 1.1.3 (Webmail)");
  message.setHeader("X-Originating-IP", request.getRemoteAddr());

  boolean replied = msgid != null;
  boolean forwarded = false;
  if (request.getParameter("uid") != null)
  { MailFolder folder = webmail.getFolder();
    try
    { folder.open(replied ? MailFolder.READ_WRITE : MailFolder.READ_ONLY);
      long uid = Long.parseLong(request.getParameter("uid"));
      MailMessage msg = folder.getMessage(uid);

      if (replied)  // replied message
        msg.setFlag(MailFlag.ANSWERED, true);
      else  // forwarded message, so attach the original message
      { forwarded = true;
        MimePartBuilder part = new MimePartBuilder();
        part.setName("Text");
        part.setContent(text);
        message.addMimePart(part);

        part = new MimePartBuilder();
        part.setName("Forwarded message");
        part.setContent(msg.getInputStream(), "message/rfc822", "7bit");
        message.addMimePart(part);
        message.setContentType("multipart/mixed");
      }
    }
    finally
    { folder.close(false);
    }
  }
  if (request.getParameter("localFile.file-name") != null)  // custom attachment
  { MimePartBuilder part = new MimePartBuilder();

    String name = request.getParameter("localFile.file-name");
    String type = request.getParameter("localFile.content-type");
    File file = (File)request.getAttribute("localFile.content");
    
    part.setName("Message Text");
    part.setContent(text);
    message.addMimePart(part);

    part = new MimePartBuilder();
    part.setName(name);
    part.setContent(new FileInputStream(file), type, "base64");
    message.addMimePart(part);
    message.setContentType("multipart/mixed");    
  }
  else if (!forwarded)  // forwarded already includes the text
    message.setContent(text);
  
  MainServer main = Main.getMainServer();
  List services = main.getServices(SMTPServer.class);
  if (services.isEmpty())
    throw new RuntimeException("No SMTPServer instance found");
  SMTPServer server = (SMTPServer)services.get(0);
  server.sendMessage(message);

  String folder = options.getSentFolder();
  if (folder.length() > 0)
  { Address addr = new Address(from);
    server.storeMessage(request.getRemoteUser(), folder, addr.getAddress(), message.getRawInputStream());
  }
%>
<script language="JavaScript">
  window.alert("Message has been sent successfully!");
  window.close();
</script>
